#include "analysisFunction.h"

void estCovar(funkyPars *pars,double **loglike10,double *freq){

  fprintf(stderr,"start cover\n");
  double minFreq=0.20;
  double minPost=0.95;
  int minGeno=32;


  int *keepSNP;
  keepSNP=new int[pars->numSites];

  double *covar;
  int *keepList;
  covar = new double[pars->nInd*pars->nInd];
  keepList = new int[pars->nInd*pars->numSites];
 
  /////////////here only the posterior estimate for the genotype is used
  double **Egeno;
  Egeno = new double*[pars->numSites]; 

  double *avg;
  avg = new double[pars->numSites]; 

  
  for(int s=0;s<pars->numSites;s++)
    Egeno[s] = new double[pars->nInd];
  
  //maybe change to posterior based on frequency
  for(int s=0;s<pars->numSites;s++){
    keepSNP[s]=0;
    avg[s]=0;
    for(int i=0;i<pars->nInd;i++){
      keepList[i*pars->nInd+s]=pars->keepSites[s];
      double norm = addProtect3(
				loglike10[s][i*10+angsd::majorminor[pars->major[s]][pars->major[s]]]+2*log(1-freq[s]),
				loglike10[s][i*10+angsd::majorminor[pars->major[s]][pars->minor[s]]]+log(2)+log(freq[s])+log(1-freq[s]),
				loglike10[s][i*10+angsd::majorminor[pars->minor[s]][pars->minor[s]]]+2*log(freq[s])
				);
      double theMax = angsd::getMax(loglike10[s][i*10+angsd::majorminor[pars->major[s]][pars->major[s]]]+2*log(1-freq[s]),
			   loglike10[s][i*10+angsd::majorminor[pars->major[s]][pars->minor[s]]]+log(2)+log(freq[s])+log(1-freq[s]),
			   loglike10[s][i*10+angsd::majorminor[pars->minor[s]][pars->minor[s]]]+2*log(freq[s])
			   );
      if(exp(theMax-norm)<minPost)
	keepList[i*pars->nInd+s]=0;
      else if(norm<-20)
	keepList[i*pars->nInd+s]=0;
      else if(pars->depth[s][i]>8)
	keepList[i*pars->nInd+s]=0;
      else if(pars->depth[s][i]<4)
	keepList[i*pars->nInd+s]=0;
      else if(loglike10[s][i*10+angsd::majorminor[pars->major[s]][pars->major[s]]]+
	 loglike10[s][i*10+angsd::majorminor[pars->major[s]][pars->minor[s]]]+
	 loglike10[s][i*10+angsd::majorminor[pars->minor[s]][pars->minor[s]]]
	 >-0.0001)//anders
        keepList[i*pars->nInd+s]=0;
      if(keepList[i*pars->nInd+s])
	keepSNP[s]++;
      Egeno[s][i]=exp(loglike10[s][i*10+angsd::majorminor[pars->major[s]][pars->minor[s]]]+log(2)+log(freq[s])+log(1-freq[s])-norm)+
	2*exp(loglike10[s][i*10+angsd::majorminor[pars->minor[s]][pars->minor[s]]]+2*log(freq[s])- norm);
      avg[s]+=Egeno[s][i];
    }
    avg[s]=avg[s]/pars->nInd;
  }
  ////////////


  ////////////covariance matrix
  //might try to change the order of the loops if this is too slow. Hopefully the compiler is smart enoght
  int nPolySites;
  for(int ind1=0;ind1<pars->nInd;ind1++){
    for(int ind2=0;ind2<pars->nInd;ind2++){
      covar[ind1*pars->nInd+ind2]=0;
      nPolySites=0;
      for(int s=0;s<pars->numSites;s++){
	if(keepSNP[s]<minGeno)
	  continue;
	if(freq[s]<minFreq||freq[s]>1-minFreq||keepList[ind1*pars->nInd+s]==0||keepList[ind2*pars->nInd+s]==0)
	  continue;
	covar[ind1*pars->nInd+ind2]+=
	  (Egeno[s][ind1]-avg[s])/sqrt(freq[s]*(1-freq[s]))*
	  (Egeno[s][ind2]-avg[s])/sqrt(freq[s]*(1-freq[s])); //remove sqrt at some point
	nPolySites++;
      }
      covar[ind1*pars->nInd+ind2]=covar[ind1*pars->nInd+ind2]/nPolySites;
    }
  }
  for(int ind1=0;ind1<pars->nInd;ind1++){
    for(int ind2=0;ind2<pars->nInd;ind2++)
      fprintf(stdout,"%f\t",covar[ind1*pars->nInd+ind2]);
    fprintf(stdout,"\n");
  }
  int sumKeep=0;
  for(int s=0;s<pars->numSites;s++)
    for(int i=0;i<pars->nInd;i++)
      sumKeep+=keepList[i*pars->nInd+s];

  int sumKeepSNP=0;
  for(int s=0;s<pars->numSites;s++)
    if(keepSNP[s]>=minGeno)
      sumKeepSNP++;
  /////////////clean up
    for(int i=0;i<pars->numSites;i++)
      delete [] Egeno[i];
    delete [] Egeno;
    delete [] avg;
    delete [] covar;
    delete [] keepSNP;
    ////////////
    fprintf(stderr,"end cover. %d genotypes %d SNPs\n",sumKeep,sumKeepSNP);
  //plot(eigen(read.table("covar"))$vector[,1:2])
  //plot(eigen(r<-read.table("covar"))$vector[,1:2],col=rep(1:2,c(32,73-32)))

}
